#include "fifteen_objects.h"
#include "fifteen_resources.h"


// TFT module connections
char TFT_DataPort at PORTJ;
sbit TFT_RST at LATD3_bit;
sbit TFT_BLED at LATC2_bit;
sbit TFT_RS at LATE0_bit;
sbit TFT_CS at LATD2_bit;
sbit TFT_RD at LATH1_bit;
sbit TFT_WR at LATH2_bit;
char TFT_DataPort_Direction at TRISJ;
sbit TFT_RST_Direction at TRISD3_bit;
sbit TFT_BLED_Direction at TRISC2_bit;
sbit TFT_RS_Direction at TRISE0_bit;
sbit TFT_CS_Direction at TRISD2_bit;
sbit TFT_RD_Direction at TRISH1_bit;
sbit TFT_WR_Direction at TRISH2_bit;
// End TFT module connections

// Touch Panel module connections
sbit DriveX_Left at LATA0_bit;
sbit DriveX_Right at LATD7_bit;
sbit DriveY_Up at LATA1_bit;
sbit DriveY_Down at LATD4_bit;
sbit DriveX_Left_Direction at TRISA0_bit;
sbit DriveX_Right_Direction at TRISD7_bit;
sbit DriveY_Up_Direction at TRISA1_bit;
sbit DriveY_Down_Direction at TRISD4_bit;
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 750;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
short button_order;
TLabel *local_label;
TLabel *exec_label;
short label_order;
TBox *local_box;
TBox *exec_box;
short box_order;


void Init_ADC() {
  PLLEN_bit = 1;
  Delay_ms(150);
  ANCON0 = 0xF0; // All pins to digital
  ANCON1 = 0xFF;
  ADC_Init();
}
static void InitializeTouchPanel() {
  Init_ADC();
  TFT_Init(240, 320);

  TP_TFT_Init(240, 320, 0, 1);                                  // Initialize touch panel
  TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}

void Calibrate() {
  TFT_Set_Pen(CL_WHITE, 3);
  TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
  TFT_Write_Text("Touch selected corners for calibration", 1, 150);
  TFT_Line(229, 309, 239, 319);
  TFT_Line(233, 319, 239, 319);
  TFT_Line(239, 313, 239, 319);
  TFT_Write_Text("first here", 160, 290);

  TP_TFT_Calibrate_Min();                      // Calibration of bottom left corner
  Delay_ms(500);

  TFT_Set_Pen(CL_BLACK, 3);
  TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
  TFT_Line(229, 309, 239, 319);
  TFT_Line(233, 319, 239, 319);
  TFT_Line(239, 313, 239, 319);
  TFT_Write_Text("first here", 160, 290);

  TFT_Set_Pen(CL_WHITE, 3);
  TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
  TFT_Line(0, 0, 10, 10);
  TFT_Line(0, 0, 6, 0);
  TFT_Line(0, 0, 0, 6);
  TFT_Write_Text("now here", 20, 5);

  TP_TFT_Calibrate_Max();                      // Calibration of bottom left corner
  Delay_ms(500);
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                MainScreen;
  TButton               Button1;
char Button1_Caption[2] = "1";

  TButton               Button2;
char Button2_Caption[2] = "2";

  TButton               Button3;
char Button3_Caption[2] = "3";

  TButton               Button4;
char Button4_Caption[2] = "4";

  TButton               Button5;
char Button5_Caption[2] = "5";

  TButton               Button6;
char Button6_Caption[2] = "6";

  TButton               Button7;
char Button7_Caption[2] = "7";

  TButton               Button8;
char Button8_Caption[2] = "8";

  TButton               Button9;
char Button9_Caption[2] = "9";

  TButton               Button10;
char Button10_Caption[3] = "10";

  TButton               Button11;
char Button11_Caption[3] = "11";

  TButton               Button12;
char Button12_Caption[3] = "12";

  TButton               Button13;
char Button13_Caption[3] = "13";

  TButton               Button14;
char Button14_Caption[3] = "14";

  TButton               Button15;
char Button15_Caption[3] = "15";

  TBox                   Box1;
  TBox                   Menu;
  TLabel                 Label1;
char Label1_Caption[4] = "New";

  TLabel                 Label2;
char Label2_Caption[27] = "MikroElektronika - Fifteen";

  TLabel                 Label4;
char Label4_Caption[5] = "Help";

  TBox                   StatusBar;
  TLabel                 Label6;
char Label6_Caption[6] = "00:00";

  TLabel                 Label7;
char Label7_Caption[6] = "Time:";

  TButton               Empty;
char Empty_Caption[1] = "";

  TButton                * const code Screen1_Buttons[16]=
         {
         &Button1,             
         &Button2,             
         &Button3,             
         &Button4,             
         &Button5,             
         &Button6,             
         &Button7,             
         &Button8,             
         &Button9,             
         &Button10,            
         &Button11,            
         &Button12,            
         &Button13,            
         &Button14,            
         &Button15,            
         &Empty                
         };
  TLabel                 * const code Screen1_Labels[5]=
         {
         &Label1,              
         &Label2,              
         &Label4,              
         &Label6,              
         &Label7               
         };
  TBox                   * const code Screen1_Boxes[3]=
         {
         &Box1,                
         &Menu,                
         &StatusBar            
         };


  TScreen                Help;
  TBox                   Box5;
  TBox                   Box6;
  TLabel                 Label13;
char Label13_Caption[5] = "Game";

  TLabel                 Label14;
char Label14_Caption[27] = "MikroElektronika - Fifteen";

  TLabel                 Label16;
char Label16_Caption[5] = "Help";

  TBox                   Box7;
  TLabel                 Label30;
char Label30_Caption[41] = "Goal of the game 'Fifteen' is to sort 15";

  TLabel                 Label31;
char Label31_Caption[6] = "Help ";

  TLabel                 Label32;
char Label32_Caption[41] = "elements in 4x4 matrix, leaving the last";

  TLabel                 Label33;
char Label33_Caption[29] = "element in the matrix empty.";

  TLabel                 Label34;
char Label34_Caption[47] = "Elements are initially randomly distributed in";

  TLabel                 Label35;
char Label35_Caption[42] = "the matrix. Game begins when player makes";

  TLabel                 Label36;
char Label36_Caption[42] = "the first move, and timer starts tracking";

  TLabel                 Label37;
char Label37_Caption[42] = "elapsed time. The sooner the player sorts";

  TLabel                 Label38;
char Label38_Caption[42] = "the elements in the matrix, the better is";

  TLabel                 Label39;
char Label39_Caption[19] = "his overall score.";

  TLabel                 * const code Screen2_Labels[13]=
         {
         &Label13,             
         &Label14,             
         &Label16,             
         &Label30,             
         &Label31,             
         &Label32,             
         &Label33,             
         &Label34,             
         &Label35,             
         &Label36,             
         &Label37,             
         &Label38,             
         &Label39              
         };
  TBox                   * const code Screen2_Boxes[3]=
         {
         &Box5,                
         &Box6,                
         &Box7                 
         };


  TScreen                Victory;
  TBox                   Box13;
  TBox                   Box11;
  TLabel                 Label43;
char Label43_Caption[5] = "Game";

  TLabel                 Label44;
char Label44_Caption[27] = "MikroElektronika - Fifteen";

  TLabel                 Label46;
char Label46_Caption[5] = "Help";

  TBox                   Box12;
  TLabel                 Label48;
char Label48_Caption[16] = "Congratulations";

  TLabel                 Label49;
char Label49_Caption[9] = "You Won!";

  TLabel                 Label50;
char Label50_Caption[14] = "Time Elapsed:";

  TLabel                 Label51;
char Label51_Caption[6] = "00:00";

  TButton               Button21;
char Button21_Caption[3] = "OK";

  TButton                * const code Screen3_Buttons[1]=
         {
         &Button21             
         };
  TLabel                 * const code Screen3_Labels[7]=
         {
         &Label43,             
         &Label44,             
         &Label46,             
         &Label48,             
         &Label49,             
         &Label50,             
         &Label51              
         };
  TBox                   * const code Screen3_Boxes[3]=
         {
         &Box13,               
         &Box11,               
         &Box12                
         };




static void InitializeObjects() {
  MainScreen.Color                     = 0x0000;
  MainScreen.Width                     = 240;
  MainScreen.Height                    = 320;
  MainScreen.ButtonsCount              = 16;
  MainScreen.Buttons                   = Screen1_Buttons;
  MainScreen.LabelsCount               = 5;
  MainScreen.Labels                    = Screen1_Labels;
  MainScreen.BoxesCount                = 3;
  MainScreen.Boxes                     = Screen1_Boxes;
  MainScreen.ObjectsCount              = 24;

  Help.Color                     = 0x0000;
  Help.Width                     = 240;
  Help.Height                    = 320;
  Help.ButtonsCount              = 0;
  Help.LabelsCount               = 13;
  Help.Labels                    = Screen2_Labels;
  Help.BoxesCount                = 3;
  Help.Boxes                     = Screen2_Boxes;
  Help.ObjectsCount              = 16;

  Victory.Color                     = 0x0000;
  Victory.Width                     = 240;
  Victory.Height                    = 320;
  Victory.ButtonsCount              = 1;
  Victory.Buttons                   = Screen3_Buttons;
  Victory.LabelsCount               = 7;
  Victory.Labels                    = Screen3_Labels;
  Victory.BoxesCount                = 3;
  Victory.Boxes                     = Screen3_Boxes;
  Victory.ObjectsCount              = 11;


  Button1.OwnerScreen     = &MainScreen;
  Button1.Order           = 0;
  Button1.Left            = 0;
  Button1.Top             = 55;
  Button1.Width           = 60;
  Button1.Height          = 60;
  Button1.Pen_Width       = 1;
  Button1.Pen_Color       = 0x0000;
  Button1.Visible         = 1;
  Button1.Active          = 1;
  Button1.Transparent     = 1;
  Button1.Caption         = Button1_Caption;
  Button1.FontName        = Arial34x41_Bold;
  Button1.PressColEnabled = 1;
  Button1.Font_Color      = 0x0000;
  Button1.Gradient        = 1;
  Button1.Gradient_Orientation    = 0;
  Button1.Gradient_Start_Color    = 0x4E4E;
  Button1.Gradient_End_Color      = 0x2CA9;
  Button1.Color           = 0xC618;
  Button1.Press_Color     = 0xC618;
  Button1.OnUpPtr         = 0;
  Button1.OnDownPtr       = Button1Down;
  Button1.OnClickPtr      = 0;
  Button1.OnPressPtr      = 0;

  Button2.OwnerScreen     = &MainScreen;
  Button2.Order           = 1;
  Button2.Left            = 60;
  Button2.Top             = 55;
  Button2.Width           = 60;
  Button2.Height          = 60;
  Button2.Pen_Width       = 1;
  Button2.Pen_Color       = 0x0000;
  Button2.Visible         = 1;
  Button2.Active          = 1;
  Button2.Transparent     = 1;
  Button2.Caption         = Button2_Caption;
  Button2.FontName        = Arial34x41_Bold;
  Button2.PressColEnabled = 1;
  Button2.Font_Color      = 0x0000;
  Button2.Gradient        = 1;
  Button2.Gradient_Orientation    = 0;
  Button2.Gradient_Start_Color    = 0x4E4E;
  Button2.Gradient_End_Color      = 0x2CA9;
  Button2.Color           = 0xC618;
  Button2.Press_Color     = 0xC618;
  Button2.OnUpPtr         = 0;
  Button2.OnDownPtr       = Button2Down;
  Button2.OnClickPtr      = 0;
  Button2.OnPressPtr      = 0;

  Button3.OwnerScreen     = &MainScreen;
  Button3.Order           = 2;
  Button3.Left            = 120;
  Button3.Top             = 55;
  Button3.Width           = 60;
  Button3.Height          = 60;
  Button3.Pen_Width       = 1;
  Button3.Pen_Color       = 0x0000;
  Button3.Visible         = 1;
  Button3.Active          = 1;
  Button3.Transparent     = 1;
  Button3.Caption         = Button3_Caption;
  Button3.FontName        = Arial34x41_Bold;
  Button3.PressColEnabled = 1;
  Button3.Font_Color      = 0x0000;
  Button3.Gradient        = 1;
  Button3.Gradient_Orientation    = 0;
  Button3.Gradient_Start_Color    = 0x4E4E;
  Button3.Gradient_End_Color      = 0x2CA9;
  Button3.Color           = 0xC618;
  Button3.Press_Color     = 0xC618;
  Button3.OnUpPtr         = 0;
  Button3.OnDownPtr       = Button3Down;
  Button3.OnClickPtr      = 0;
  Button3.OnPressPtr      = 0;

  Button4.OwnerScreen     = &MainScreen;
  Button4.Order           = 3;
  Button4.Left            = 180;
  Button4.Top             = 55;
  Button4.Width           = 60;
  Button4.Height          = 60;
  Button4.Pen_Width       = 1;
  Button4.Pen_Color       = 0x0000;
  Button4.Visible         = 1;
  Button4.Active          = 1;
  Button4.Transparent     = 1;
  Button4.Caption         = Button4_Caption;
  Button4.FontName        = Arial34x41_Bold;
  Button4.PressColEnabled = 1;
  Button4.Font_Color      = 0x0000;
  Button4.Gradient        = 1;
  Button4.Gradient_Orientation    = 0;
  Button4.Gradient_Start_Color    = 0x4E4E;
  Button4.Gradient_End_Color      = 0x2CA9;
  Button4.Color           = 0xC618;
  Button4.Press_Color     = 0xC618;
  Button4.OnUpPtr         = 0;
  Button4.OnDownPtr       = Button4Down;
  Button4.OnClickPtr      = 0;
  Button4.OnPressPtr      = 0;

  Button5.OwnerScreen     = &MainScreen;
  Button5.Order           = 4;
  Button5.Left            = 0;
  Button5.Top             = 115;
  Button5.Width           = 60;
  Button5.Height          = 60;
  Button5.Pen_Width       = 1;
  Button5.Pen_Color       = 0x0000;
  Button5.Visible         = 1;
  Button5.Active          = 1;
  Button5.Transparent     = 1;
  Button5.Caption         = Button5_Caption;
  Button5.FontName        = Arial34x41_Bold;
  Button5.PressColEnabled = 1;
  Button5.Font_Color      = 0x0000;
  Button5.Gradient        = 1;
  Button5.Gradient_Orientation    = 0;
  Button5.Gradient_Start_Color    = 0xC618;
  Button5.Gradient_End_Color      = 0x8410;
  Button5.Color           = 0x8410;
  Button5.Press_Color     = 0xC618;
  Button5.OnUpPtr         = 0;
  Button5.OnDownPtr       = Button5Down;
  Button5.OnClickPtr      = 0;
  Button5.OnPressPtr      = 0;

  Button6.OwnerScreen     = &MainScreen;
  Button6.Order           = 5;
  Button6.Left            = 60;
  Button6.Top             = 115;
  Button6.Width           = 60;
  Button6.Height          = 60;
  Button6.Pen_Width       = 1;
  Button6.Pen_Color       = 0x0000;
  Button6.Visible         = 1;
  Button6.Active          = 1;
  Button6.Transparent     = 1;
  Button6.Caption         = Button6_Caption;
  Button6.FontName        = Arial34x41_Bold;
  Button6.PressColEnabled = 1;
  Button6.Font_Color      = 0x0000;
  Button6.Gradient        = 1;
  Button6.Gradient_Orientation    = 0;
  Button6.Gradient_Start_Color    = 0xC618;
  Button6.Gradient_End_Color      = 0x8410;
  Button6.Color           = 0x8410;
  Button6.Press_Color     = 0xC618;
  Button6.OnUpPtr         = 0;
  Button6.OnDownPtr       = Button6Down;
  Button6.OnClickPtr      = 0;
  Button6.OnPressPtr      = 0;

  Button7.OwnerScreen     = &MainScreen;
  Button7.Order           = 6;
  Button7.Left            = 120;
  Button7.Top             = 115;
  Button7.Width           = 60;
  Button7.Height          = 60;
  Button7.Pen_Width       = 1;
  Button7.Pen_Color       = 0x0000;
  Button7.Visible         = 1;
  Button7.Active          = 1;
  Button7.Transparent     = 1;
  Button7.Caption         = Button7_Caption;
  Button7.FontName        = Arial34x41_Bold;
  Button7.PressColEnabled = 1;
  Button7.Font_Color      = 0x0000;
  Button7.Gradient        = 1;
  Button7.Gradient_Orientation    = 0;
  Button7.Gradient_Start_Color    = 0xC618;
  Button7.Gradient_End_Color      = 0x8410;
  Button7.Color           = 0x8410;
  Button7.Press_Color     = 0xC618;
  Button7.OnUpPtr         = 0;
  Button7.OnDownPtr       = Button7Down;
  Button7.OnClickPtr      = 0;
  Button7.OnPressPtr      = 0;

  Button8.OwnerScreen     = &MainScreen;
  Button8.Order           = 7;
  Button8.Left            = 180;
  Button8.Top             = 115;
  Button8.Width           = 60;
  Button8.Height          = 60;
  Button8.Pen_Width       = 1;
  Button8.Pen_Color       = 0x0000;
  Button8.Visible         = 1;
  Button8.Active          = 1;
  Button8.Transparent     = 1;
  Button8.Caption         = Button8_Caption;
  Button8.FontName        = Arial34x41_Bold;
  Button8.PressColEnabled = 1;
  Button8.Font_Color      = 0x0000;
  Button8.Gradient        = 1;
  Button8.Gradient_Orientation    = 0;
  Button8.Gradient_Start_Color    = 0xC618;
  Button8.Gradient_End_Color      = 0x8410;
  Button8.Color           = 0x8410;
  Button8.Press_Color     = 0xC618;
  Button8.OnUpPtr         = 0;
  Button8.OnDownPtr       = Button8Down;
  Button8.OnClickPtr      = 0;
  Button8.OnPressPtr      = 0;

  Button9.OwnerScreen     = &MainScreen;
  Button9.Order           = 8;
  Button9.Left            = 0;
  Button9.Top             = 175;
  Button9.Width           = 60;
  Button9.Height          = 60;
  Button9.Pen_Width       = 1;
  Button9.Pen_Color       = 0x0000;
  Button9.Visible         = 1;
  Button9.Active          = 1;
  Button9.Transparent     = 1;
  Button9.Caption         = Button9_Caption;
  Button9.FontName        = Arial34x41_Bold;
  Button9.PressColEnabled = 1;
  Button9.Font_Color      = 0x0000;
  Button9.Gradient        = 1;
  Button9.Gradient_Orientation    = 0;
  Button9.Gradient_Start_Color    = 0xC618;
  Button9.Gradient_End_Color      = 0x8410;
  Button9.Color           = 0x8410;
  Button9.Press_Color     = 0xC618;
  Button9.OnUpPtr         = 0;
  Button9.OnDownPtr       = Button9Down;
  Button9.OnClickPtr      = 0;
  Button9.OnPressPtr      = 0;

  Button10.OwnerScreen     = &MainScreen;
  Button10.Order           = 9;
  Button10.Left            = 60;
  Button10.Top             = 175;
  Button10.Width           = 60;
  Button10.Height          = 60;
  Button10.Pen_Width       = 1;
  Button10.Pen_Color       = 0x0000;
  Button10.Visible         = 1;
  Button10.Active          = 1;
  Button10.Transparent     = 1;
  Button10.Caption         = Button10_Caption;
  Button10.FontName        = Arial34x41_Bold;
  Button10.PressColEnabled = 1;
  Button10.Font_Color      = 0x0000;
  Button10.Gradient        = 1;
  Button10.Gradient_Orientation    = 0;
  Button10.Gradient_Start_Color    = 0xC618;
  Button10.Gradient_End_Color      = 0x8410;
  Button10.Color           = 0x8410;
  Button10.Press_Color     = 0xC618;
  Button10.OnUpPtr         = 0;
  Button10.OnDownPtr       = Button10Down;
  Button10.OnClickPtr      = 0;
  Button10.OnPressPtr      = 0;

  Button11.OwnerScreen     = &MainScreen;
  Button11.Order           = 10;
  Button11.Left            = 120;
  Button11.Top             = 175;
  Button11.Width           = 60;
  Button11.Height          = 60;
  Button11.Pen_Width       = 1;
  Button11.Pen_Color       = 0x0000;
  Button11.Visible         = 1;
  Button11.Active          = 1;
  Button11.Transparent     = 1;
  Button11.Caption         = Button11_Caption;
  Button11.FontName        = Arial34x41_Bold;
  Button11.PressColEnabled = 1;
  Button11.Font_Color      = 0x0000;
  Button11.Gradient        = 1;
  Button11.Gradient_Orientation    = 0;
  Button11.Gradient_Start_Color    = 0xC618;
  Button11.Gradient_End_Color      = 0x8410;
  Button11.Color           = 0x8410;
  Button11.Press_Color     = 0xC618;
  Button11.OnUpPtr         = 0;
  Button11.OnDownPtr       = Button11Down;
  Button11.OnClickPtr      = 0;
  Button11.OnPressPtr      = 0;

  Button12.OwnerScreen     = &MainScreen;
  Button12.Order           = 11;
  Button12.Left            = 180;
  Button12.Top             = 175;
  Button12.Width           = 60;
  Button12.Height          = 60;
  Button12.Pen_Width       = 1;
  Button12.Pen_Color       = 0x0000;
  Button12.Visible         = 1;
  Button12.Active          = 1;
  Button12.Transparent     = 1;
  Button12.Caption         = Button12_Caption;
  Button12.FontName        = Arial34x41_Bold;
  Button12.PressColEnabled = 1;
  Button12.Font_Color      = 0x0000;
  Button12.Gradient        = 1;
  Button12.Gradient_Orientation    = 0;
  Button12.Gradient_Start_Color    = 0xC618;
  Button12.Gradient_End_Color      = 0x8410;
  Button12.Color           = 0x8410;
  Button12.Press_Color     = 0xC618;
  Button12.OnUpPtr         = 0;
  Button12.OnDownPtr       = Button12Down;
  Button12.OnClickPtr      = 0;
  Button12.OnPressPtr      = 0;

  Button13.OwnerScreen     = &MainScreen;
  Button13.Order           = 12;
  Button13.Left            = 0;
  Button13.Top             = 235;
  Button13.Width           = 60;
  Button13.Height          = 60;
  Button13.Pen_Width       = 1;
  Button13.Pen_Color       = 0x0000;
  Button13.Visible         = 1;
  Button13.Active          = 1;
  Button13.Transparent     = 1;
  Button13.Caption         = Button13_Caption;
  Button13.FontName        = Arial34x41_Bold;
  Button13.PressColEnabled = 1;
  Button13.Font_Color      = 0x0000;
  Button13.Gradient        = 1;
  Button13.Gradient_Orientation    = 0;
  Button13.Gradient_Start_Color    = 0x4E4E;
  Button13.Gradient_End_Color      = 0x2CA9;
  Button13.Color           = 0xC618;
  Button13.Press_Color     = 0xC618;
  Button13.OnUpPtr         = 0;
  Button13.OnDownPtr       = Button13Down;
  Button13.OnClickPtr      = 0;
  Button13.OnPressPtr      = 0;

  Button14.OwnerScreen     = &MainScreen;
  Button14.Order           = 13;
  Button14.Left            = 60;
  Button14.Top             = 235;
  Button14.Width           = 60;
  Button14.Height          = 60;
  Button14.Pen_Width       = 1;
  Button14.Pen_Color       = 0x0000;
  Button14.Visible         = 1;
  Button14.Active          = 1;
  Button14.Transparent     = 1;
  Button14.Caption         = Button14_Caption;
  Button14.FontName        = Arial34x41_Bold;
  Button14.PressColEnabled = 1;
  Button14.Font_Color      = 0x0000;
  Button14.Gradient        = 1;
  Button14.Gradient_Orientation    = 0;
  Button14.Gradient_Start_Color    = 0x4E4E;
  Button14.Gradient_End_Color      = 0x2CA9;
  Button14.Color           = 0xC618;
  Button14.Press_Color     = 0xC618;
  Button14.OnUpPtr         = 0;
  Button14.OnDownPtr       = Button14Down;
  Button14.OnClickPtr      = 0;
  Button14.OnPressPtr      = 0;

  Button15.OwnerScreen     = &MainScreen;
  Button15.Order           = 14;
  Button15.Left            = 120;
  Button15.Top             = 235;
  Button15.Width           = 60;
  Button15.Height          = 60;
  Button15.Pen_Width       = 1;
  Button15.Pen_Color       = 0x0000;
  Button15.Visible         = 1;
  Button15.Active          = 1;
  Button15.Transparent     = 1;
  Button15.Caption         = Button15_Caption;
  Button15.FontName        = Arial34x41_Bold;
  Button15.PressColEnabled = 1;
  Button15.Font_Color      = 0x0000;
  Button15.Gradient        = 1;
  Button15.Gradient_Orientation    = 0;
  Button15.Gradient_Start_Color    = 0x4E4E;
  Button15.Gradient_End_Color      = 0x2CA9;
  Button15.Color           = 0xC618;
  Button15.Press_Color     = 0xC618;
  Button15.OnUpPtr         = 0;
  Button15.OnDownPtr       = Button15Down;
  Button15.OnClickPtr      = 0;
  Button15.OnPressPtr      = 0;

  Box1.OwnerScreen     = &MainScreen;
  Box1.Order           = 15;
  Box1.Left            = 0;
  Box1.Top             = 0;
  Box1.Width           = 240;
  Box1.Height          = 30;
  Box1.Pen_Width       = 1;
  Box1.Pen_Color       = 0x0000;
  Box1.Visible         = 1;
  Box1.Active          = 1;
  Box1.Transparent     = 1;
  Box1.Gradient        = 1;
  Box1.Gradient_Orientation    = 0;
  Box1.Gradient_Start_Color    = 0x001F;
  Box1.Gradient_End_Color      = 0x0017;
  Box1.Color           = 0xC618;
  Box1.PressColEnabled     = 0;
  Box1.Press_Color     = 0x8410;
  Box1.OnUpPtr         = 0;
  Box1.OnDownPtr       = 0;
  Box1.OnClickPtr      = 0;
  Box1.OnPressPtr      = 0;

  Menu.OwnerScreen     = &MainScreen;
  Menu.Order           = 16;
  Menu.Left            = 0;
  Menu.Top             = 30;
  Menu.Width           = 240;
  Menu.Height          = 25;
  Menu.Pen_Width       = 1;
  Menu.Pen_Color       = 0x0000;
  Menu.Visible         = 1;
  Menu.Active          = 1;
  Menu.Transparent     = 1;
  Menu.Gradient        = 0;
  Menu.Gradient_Orientation    = 0;
  Menu.Gradient_Start_Color    = 0xFFFF;
  Menu.Gradient_End_Color      = 0xC618;
  Menu.Color           = 0xC618;
  Menu.PressColEnabled     = 0;
  Menu.Press_Color     = 0x8410;
  Menu.OnUpPtr         = 0;
  Menu.OnDownPtr       = 0;
  Menu.OnClickPtr      = 0;
  Menu.OnPressPtr      = 0;

  Label1.OwnerScreen     = &MainScreen;
  Label1.Order          = 17;
  Label1.Left           = 9;
  Label1.Top            = 36;
  Label1.Width          = 29;
  Label1.Height         = 12;
  Label1.Visible        = 1;
  Label1.Active         = 1;
  Label1.Caption        = Label1_Caption;
  Label1.FontName       = Tahoma11x13_Regular;
  Label1.Font_Color     = 0x0000;
  Label1.OnUpPtr         = 0;
  Label1.OnDownPtr       = NewGame;
  Label1.OnClickPtr      = 0;
  Label1.OnPressPtr      = 0;

  Label2.OwnerScreen     = &MainScreen;
  Label2.Order          = 18;
  Label2.Left           = 5;
  Label2.Top            = 8;
  Label2.Width          = 193;
  Label2.Height         = 15;
  Label2.Visible        = 1;
  Label2.Active         = 1;
  Label2.Caption        = Label2_Caption;
  Label2.FontName       = Tahoma14x16_Bold;
  Label2.Font_Color     = 0xFFFF;
  Label2.OnUpPtr         = 0;
  Label2.OnDownPtr       = 0;
  Label2.OnClickPtr      = 0;
  Label2.OnPressPtr      = 0;

  Label4.OwnerScreen     = &MainScreen;
  Label4.Order          = 19;
  Label4.Left           = 42;
  Label4.Top            = 36;
  Label4.Width          = 30;
  Label4.Height         = 12;
  Label4.Visible        = 1;
  Label4.Active         = 1;
  Label4.Caption        = Label4_Caption;
  Label4.FontName       = Tahoma11x13_Regular;
  Label4.Font_Color     = 0x0000;
  Label4.OnUpPtr         = 0;
  Label4.OnDownPtr       = ShowHelpScreen;
  Label4.OnClickPtr      = 0;
  Label4.OnPressPtr      = 0;

  StatusBar.OwnerScreen     = &MainScreen;
  StatusBar.Order           = 20;
  StatusBar.Left            = 0;
  StatusBar.Top             = 295;
  StatusBar.Width           = 240;
  StatusBar.Height          = 25;
  StatusBar.Pen_Width       = 1;
  StatusBar.Pen_Color       = 0x0000;
  StatusBar.Visible         = 1;
  StatusBar.Active          = 1;
  StatusBar.Transparent     = 1;
  StatusBar.Gradient        = 0;
  StatusBar.Gradient_Orientation    = 0;
  StatusBar.Gradient_Start_Color    = 0xFFFF;
  StatusBar.Gradient_End_Color      = 0xC618;
  StatusBar.Color           = 0xC618;
  StatusBar.PressColEnabled     = 0;
  StatusBar.Press_Color     = 0x8410;
  StatusBar.OnUpPtr         = 0;
  StatusBar.OnDownPtr       = 0;
  StatusBar.OnClickPtr      = 0;
  StatusBar.OnPressPtr      = 0;

  Label6.OwnerScreen     = &MainScreen;
  Label6.Order          = 21;
  Label6.Left           = 200;
  Label6.Top            = 302;
  Label6.Width          = 34;
  Label6.Height         = 12;
  Label6.Visible        = 1;
  Label6.Active         = 1;
  Label6.Caption        = Label6_Caption;
  Label6.FontName       = Tahoma11x13_Regular;
  Label6.Font_Color     = 0x0000;
  Label6.OnUpPtr         = 0;
  Label6.OnDownPtr       = 0;
  Label6.OnClickPtr      = 0;
  Label6.OnPressPtr      = 0;

  Label7.OwnerScreen     = &MainScreen;
  Label7.Order          = 22;
  Label7.Left           = 165;
  Label7.Top            = 301;
  Label7.Width          = 35;
  Label7.Height         = 12;
  Label7.Visible        = 1;
  Label7.Active         = 1;
  Label7.Caption        = Label7_Caption;
  Label7.FontName       = Tahoma11x13_Regular;
  Label7.Font_Color     = 0x0000;
  Label7.OnUpPtr         = 0;
  Label7.OnDownPtr       = 0;
  Label7.OnClickPtr      = 0;
  Label7.OnPressPtr      = 0;

  Empty.OwnerScreen     = &MainScreen;
  Empty.Order           = 23;
  Empty.Left            = 180;
  Empty.Top             = 235;
  Empty.Width           = 60;
  Empty.Height          = 60;
  Empty.Pen_Width       = 1;
  Empty.Pen_Color       = 0x0000;
  Empty.Visible         = 1;
  Empty.Active          = 1;
  Empty.Transparent     = 1;
  Empty.Caption         = Empty_Caption;
  Empty.FontName        = Tahoma11x13_Regular;
  Empty.PressColEnabled = 0;
  Empty.Font_Color      = 0x0000;
  Empty.Gradient        = 0;
  Empty.Gradient_Orientation    = 0;
  Empty.Gradient_Start_Color    = 0xFFFF;
  Empty.Gradient_End_Color      = 0xC618;
  Empty.Color           = 0x0000;
  Empty.Press_Color     = 0xC618;
  Empty.OnUpPtr         = 0;
  Empty.OnDownPtr       = 0;
  Empty.OnClickPtr      = 0;
  Empty.OnPressPtr      = 0;

  Box5.OwnerScreen     = &Help;
  Box5.Order           = 0;
  Box5.Left            = 0;
  Box5.Top             = 0;
  Box5.Width           = 240;
  Box5.Height          = 30;
  Box5.Pen_Width       = 1;
  Box5.Pen_Color       = 0x0000;
  Box5.Visible         = 1;
  Box5.Active          = 1;
  Box5.Transparent     = 1;
  Box5.Gradient        = 1;
  Box5.Gradient_Orientation    = 0;
  Box5.Gradient_Start_Color    = 0x001F;
  Box5.Gradient_End_Color      = 0x0017;
  Box5.Color           = 0xC618;
  Box5.PressColEnabled     = 0;
  Box5.Press_Color     = 0x8410;
  Box5.OnUpPtr         = 0;
  Box5.OnDownPtr       = 0;
  Box5.OnClickPtr      = 0;
  Box5.OnPressPtr      = 0;

  Box6.OwnerScreen     = &Help;
  Box6.Order           = 1;
  Box6.Left            = 0;
  Box6.Top             = 30;
  Box6.Width           = 240;
  Box6.Height          = 25;
  Box6.Pen_Width       = 1;
  Box6.Pen_Color       = 0x0000;
  Box6.Visible         = 1;
  Box6.Active          = 1;
  Box6.Transparent     = 1;
  Box6.Gradient        = 0;
  Box6.Gradient_Orientation    = 0;
  Box6.Gradient_Start_Color    = 0xFFFF;
  Box6.Gradient_End_Color      = 0xC618;
  Box6.Color           = 0xC618;
  Box6.PressColEnabled     = 0;
  Box6.Press_Color     = 0x8410;
  Box6.OnUpPtr         = 0;
  Box6.OnDownPtr       = 0;
  Box6.OnClickPtr      = 0;
  Box6.OnPressPtr      = 0;

  Label13.OwnerScreen     = &Help;
  Label13.Order          = 2;
  Label13.Left           = 9;
  Label13.Top            = 36;
  Label13.Width          = 36;
  Label13.Height         = 12;
  Label13.Visible        = 1;
  Label13.Active         = 1;
  Label13.Caption        = Label13_Caption;
  Label13.FontName       = Tahoma11x13_Regular;
  Label13.Font_Color     = 0x0000;
  Label13.OnUpPtr         = 0;
  Label13.OnDownPtr       = ShowMainScreen;
  Label13.OnClickPtr      = 0;
  Label13.OnPressPtr      = 0;

  Label14.OwnerScreen     = &Help;
  Label14.Order          = 3;
  Label14.Left           = 5;
  Label14.Top            = 8;
  Label14.Width          = 193;
  Label14.Height         = 15;
  Label14.Visible        = 1;
  Label14.Active         = 1;
  Label14.Caption        = Label14_Caption;
  Label14.FontName       = Tahoma14x16_Bold;
  Label14.Font_Color     = 0xFFFF;
  Label14.OnUpPtr         = 0;
  Label14.OnDownPtr       = 0;
  Label14.OnClickPtr      = 0;
  Label14.OnPressPtr      = 0;

  Label16.OwnerScreen     = &Help;
  Label16.Order          = 4;
  Label16.Left           = 49;
  Label16.Top            = 36;
  Label16.Width          = 32;
  Label16.Height         = 12;
  Label16.Visible        = 1;
  Label16.Active         = 0;
  Label16.Caption        = Label16_Caption;
  Label16.FontName       = Tahoma13x13_Bold;
  Label16.Font_Color     = 0xF800;
  Label16.OnUpPtr         = 0;
  Label16.OnDownPtr       = 0;
  Label16.OnClickPtr      = 0;
  Label16.OnPressPtr      = 0;

  Box7.OwnerScreen     = &Help;
  Box7.Order           = 5;
  Box7.Left            = 0;
  Box7.Top             = 295;
  Box7.Width           = 240;
  Box7.Height          = 25;
  Box7.Pen_Width       = 1;
  Box7.Pen_Color       = 0x0000;
  Box7.Visible         = 1;
  Box7.Active          = 1;
  Box7.Transparent     = 1;
  Box7.Gradient        = 0;
  Box7.Gradient_Orientation    = 0;
  Box7.Gradient_Start_Color    = 0xFFFF;
  Box7.Gradient_End_Color      = 0xC618;
  Box7.Color           = 0xC618;
  Box7.PressColEnabled     = 0;
  Box7.Press_Color     = 0x8410;
  Box7.OnUpPtr         = 0;
  Box7.OnDownPtr       = 0;
  Box7.OnClickPtr      = 0;
  Box7.OnPressPtr      = 0;

  Label30.OwnerScreen     = &Help;
  Label30.Order          = 6;
  Label30.Left           = 16;
  Label30.Top            = 139;
  Label30.Width          = 188;
  Label30.Height         = 12;
  Label30.Visible        = 1;
  Label30.Active         = 1;
  Label30.Caption        = Label30_Caption;
  Label30.FontName       = Tahoma11x13_Regular;
  Label30.Font_Color     = 0xFFE0;
  Label30.OnUpPtr         = 0;
  Label30.OnDownPtr       = 0;
  Label30.OnClickPtr      = 0;
  Label30.OnPressPtr      = 0;

  Label31.OwnerScreen     = &Help;
  Label31.Order          = 7;
  Label31.Left           = 58;
  Label31.Top            = 66;
  Label31.Width          = 144;
  Label31.Height         = 54;
  Label31.Visible        = 1;
  Label31.Active         = 1;
  Label31.Caption        = Label31_Caption;
  Label31.FontName       = Tahoma58x58_Bold;
  Label31.Font_Color     = 0xFFFF;
  Label31.OnUpPtr         = 0;
  Label31.OnDownPtr       = 0;
  Label31.OnClickPtr      = 0;
  Label31.OnPressPtr      = 0;

  Label32.OwnerScreen     = &Help;
  Label32.Order          = 8;
  Label32.Left           = 16;
  Label32.Top            = 154;
  Label32.Width          = 194;
  Label32.Height         = 12;
  Label32.Visible        = 1;
  Label32.Active         = 1;
  Label32.Caption        = Label32_Caption;
  Label32.FontName       = Tahoma11x13_Regular;
  Label32.Font_Color     = 0xFFE0;
  Label32.OnUpPtr         = 0;
  Label32.OnDownPtr       = 0;
  Label32.OnClickPtr      = 0;
  Label32.OnPressPtr      = 0;

  Label33.OwnerScreen     = &Help;
  Label33.Order          = 9;
  Label33.Left           = 16;
  Label33.Top            = 169;
  Label33.Width          = 147;
  Label33.Height         = 12;
  Label33.Visible        = 1;
  Label33.Active         = 1;
  Label33.Caption        = Label33_Caption;
  Label33.FontName       = Tahoma11x13_Regular;
  Label33.Font_Color     = 0xFFE0;
  Label33.OnUpPtr         = 0;
  Label33.OnDownPtr       = 0;
  Label33.OnClickPtr      = 0;
  Label33.OnPressPtr      = 0;

  Label34.OwnerScreen     = &Help;
  Label34.Order          = 10;
  Label34.Left           = 16;
  Label34.Top            = 184;
  Label34.Width          = 220;
  Label34.Height         = 12;
  Label34.Visible        = 1;
  Label34.Active         = 1;
  Label34.Caption        = Label34_Caption;
  Label34.FontName       = Tahoma11x13_Regular;
  Label34.Font_Color     = 0xFFFF;
  Label34.OnUpPtr         = 0;
  Label34.OnDownPtr       = 0;
  Label34.OnClickPtr      = 0;
  Label34.OnPressPtr      = 0;

  Label35.OwnerScreen     = &Help;
  Label35.Order          = 11;
  Label35.Left           = 16;
  Label35.Top            = 200;
  Label35.Width          = 222;
  Label35.Height         = 12;
  Label35.Visible        = 1;
  Label35.Active         = 1;
  Label35.Caption        = Label35_Caption;
  Label35.FontName       = Tahoma11x13_Regular;
  Label35.Font_Color     = 0xFFFF;
  Label35.OnUpPtr         = 0;
  Label35.OnDownPtr       = 0;
  Label35.OnClickPtr      = 0;
  Label35.OnPressPtr      = 0;

  Label36.OwnerScreen     = &Help;
  Label36.Order          = 12;
  Label36.Left           = 16;
  Label36.Top            = 215;
  Label36.Width          = 197;
  Label36.Height         = 12;
  Label36.Visible        = 1;
  Label36.Active         = 1;
  Label36.Caption        = Label36_Caption;
  Label36.FontName       = Tahoma11x13_Regular;
  Label36.Font_Color     = 0xFFFF;
  Label36.OnUpPtr         = 0;
  Label36.OnDownPtr       = 0;
  Label36.OnClickPtr      = 0;
  Label36.OnPressPtr      = 0;

  Label37.OwnerScreen     = &Help;
  Label37.Order          = 13;
  Label37.Left           = 16;
  Label37.Top            = 230;
  Label37.Width          = 205;
  Label37.Height         = 12;
  Label37.Visible        = 1;
  Label37.Active         = 1;
  Label37.Caption        = Label37_Caption;
  Label37.FontName       = Tahoma11x13_Regular;
  Label37.Font_Color     = 0xFFFF;
  Label37.OnUpPtr         = 0;
  Label37.OnDownPtr       = 0;
  Label37.OnClickPtr      = 0;
  Label37.OnPressPtr      = 0;

  Label38.OwnerScreen     = &Help;
  Label38.Order          = 14;
  Label38.Left           = 16;
  Label38.Top            = 245;
  Label38.Width          = 198;
  Label38.Height         = 12;
  Label38.Visible        = 1;
  Label38.Active         = 1;
  Label38.Caption        = Label38_Caption;
  Label38.FontName       = Tahoma11x13_Regular;
  Label38.Font_Color     = 0xFFFF;
  Label38.OnUpPtr         = 0;
  Label38.OnDownPtr       = 0;
  Label38.OnClickPtr      = 0;
  Label38.OnPressPtr      = 0;

  Label39.OwnerScreen     = &Help;
  Label39.Order          = 15;
  Label39.Left           = 16;
  Label39.Top            = 260;
  Label39.Width          = 86;
  Label39.Height         = 12;
  Label39.Visible        = 1;
  Label39.Active         = 1;
  Label39.Caption        = Label39_Caption;
  Label39.FontName       = Tahoma11x13_Regular;
  Label39.Font_Color     = 0xFFFF;
  Label39.OnUpPtr         = 0;
  Label39.OnDownPtr       = 0;
  Label39.OnClickPtr      = 0;
  Label39.OnPressPtr      = 0;

  Box13.OwnerScreen     = &Victory;
  Box13.Order           = 0;
  Box13.Left            = 0;
  Box13.Top             = 0;
  Box13.Width           = 240;
  Box13.Height          = 30;
  Box13.Pen_Width       = 1;
  Box13.Pen_Color       = 0x0000;
  Box13.Visible         = 1;
  Box13.Active          = 1;
  Box13.Transparent     = 1;
  Box13.Gradient        = 1;
  Box13.Gradient_Orientation    = 0;
  Box13.Gradient_Start_Color    = 0x001F;
  Box13.Gradient_End_Color      = 0x0017;
  Box13.Color           = 0xC618;
  Box13.PressColEnabled     = 0;
  Box13.Press_Color     = 0x8410;
  Box13.OnUpPtr         = 0;
  Box13.OnDownPtr       = 0;
  Box13.OnClickPtr      = 0;
  Box13.OnPressPtr      = 0;

  Box11.OwnerScreen     = &Victory;
  Box11.Order           = 1;
  Box11.Left            = 0;
  Box11.Top             = 30;
  Box11.Width           = 240;
  Box11.Height          = 25;
  Box11.Pen_Width       = 1;
  Box11.Pen_Color       = 0x0000;
  Box11.Visible         = 1;
  Box11.Active          = 1;
  Box11.Transparent     = 1;
  Box11.Gradient        = 0;
  Box11.Gradient_Orientation    = 0;
  Box11.Gradient_Start_Color    = 0xFFFF;
  Box11.Gradient_End_Color      = 0xC618;
  Box11.Color           = 0xC618;
  Box11.PressColEnabled     = 0;
  Box11.Press_Color     = 0x8410;
  Box11.OnUpPtr         = 0;
  Box11.OnDownPtr       = 0;
  Box11.OnClickPtr      = 0;
  Box11.OnPressPtr      = 0;

  Label43.OwnerScreen     = &Victory;
  Label43.Order          = 2;
  Label43.Left           = 9;
  Label43.Top            = 36;
  Label43.Width          = 36;
  Label43.Height         = 12;
  Label43.Visible        = 1;
  Label43.Active         = 1;
  Label43.Caption        = Label43_Caption;
  Label43.FontName       = Tahoma11x13_Regular;
  Label43.Font_Color     = 0x0000;
  Label43.OnUpPtr         = 0;
  Label43.OnDownPtr       = ShowMainScreen;
  Label43.OnClickPtr      = 0;
  Label43.OnPressPtr      = 0;

  Label44.OwnerScreen     = &Victory;
  Label44.Order          = 3;
  Label44.Left           = 5;
  Label44.Top            = 8;
  Label44.Width          = 193;
  Label44.Height         = 15;
  Label44.Visible        = 1;
  Label44.Active         = 1;
  Label44.Caption        = Label44_Caption;
  Label44.FontName       = Tahoma14x16_Bold;
  Label44.Font_Color     = 0xFFFF;
  Label44.OnUpPtr         = 0;
  Label44.OnDownPtr       = 0;
  Label44.OnClickPtr      = 0;
  Label44.OnPressPtr      = 0;

  Label46.OwnerScreen     = &Victory;
  Label46.Order          = 4;
  Label46.Left           = 53;
  Label46.Top            = 36;
  Label46.Width          = 30;
  Label46.Height         = 12;
  Label46.Visible        = 1;
  Label46.Active         = 1;
  Label46.Caption        = Label46_Caption;
  Label46.FontName       = Tahoma11x13_Regular;
  Label46.Font_Color     = 0x0000;
  Label46.OnUpPtr         = 0;
  Label46.OnDownPtr       = ShowHelpScreen;
  Label46.OnClickPtr      = 0;
  Label46.OnPressPtr      = 0;

  Box12.OwnerScreen     = &Victory;
  Box12.Order           = 5;
  Box12.Left            = 0;
  Box12.Top             = 295;
  Box12.Width           = 240;
  Box12.Height          = 25;
  Box12.Pen_Width       = 1;
  Box12.Pen_Color       = 0x0000;
  Box12.Visible         = 1;
  Box12.Active          = 1;
  Box12.Transparent     = 1;
  Box12.Gradient        = 0;
  Box12.Gradient_Orientation    = 0;
  Box12.Gradient_Start_Color    = 0xFFFF;
  Box12.Gradient_End_Color      = 0xC618;
  Box12.Color           = 0xC618;
  Box12.PressColEnabled     = 0;
  Box12.Press_Color     = 0x8410;
  Box12.OnUpPtr         = 0;
  Box12.OnDownPtr       = 0;
  Box12.OnClickPtr      = 0;
  Box12.OnPressPtr      = 0;

  Label48.OwnerScreen     = &Victory;
  Label48.Order          = 6;
  Label48.Left           = 24;
  Label48.Top            = 73;
  Label48.Width          = 196;
  Label48.Height         = 24;
  Label48.Visible        = 1;
  Label48.Active         = 1;
  Label48.Caption        = Label48_Caption;
  Label48.FontName       = Tahoma25x25_Bold;
  Label48.Font_Color     = 0xF800;
  Label48.OnUpPtr         = 0;
  Label48.OnDownPtr       = 0;
  Label48.OnClickPtr      = 0;
  Label48.OnPressPtr      = 0;

  Label49.OwnerScreen     = &Victory;
  Label49.Order          = 7;
  Label49.Left           = 19;
  Label49.Top            = 96;
  Label49.Width          = 207;
  Label49.Height         = 42;
  Label49.Visible        = 1;
  Label49.Active         = 1;
  Label49.Caption        = Label49_Caption;
  Label49.FontName       = Tahoma44x45_Bold;
  Label49.Font_Color     = 0xFFE0;
  Label49.OnUpPtr         = 0;
  Label49.OnDownPtr       = 0;
  Label49.OnClickPtr      = 0;
  Label49.OnPressPtr      = 0;

  Label50.OwnerScreen     = &Victory;
  Label50.Order          = 8;
  Label50.Left           = 35;
  Label50.Top            = 167;
  Label50.Width          = 171;
  Label50.Height         = 24;
  Label50.Visible        = 1;
  Label50.Active         = 1;
  Label50.Caption        = Label50_Caption;
  Label50.FontName       = Tahoma25x25_Bold;
  Label50.Font_Color     = 0xFFFF;
  Label50.OnUpPtr         = 0;
  Label50.OnDownPtr       = 0;
  Label50.OnClickPtr      = 0;
  Label50.OnPressPtr      = 0;

  Label51.OwnerScreen     = &Victory;
  Label51.Order          = 9;
  Label51.Left           = 82;
  Label51.Top            = 199;
  Label51.Width          = 75;
  Label51.Height         = 24;
  Label51.Visible        = 1;
  Label51.Active         = 1;
  Label51.Caption        = Label51_Caption;
  Label51.FontName       = Tahoma25x25_Bold;
  Label51.Font_Color     = 0xFFFF;
  Label51.OnUpPtr         = 0;
  Label51.OnDownPtr       = 0;
  Label51.OnClickPtr      = 0;
  Label51.OnPressPtr      = 0;

  Button21.OwnerScreen     = &Victory;
  Button21.Order           = 10;
  Button21.Left            = 81;
  Button21.Top             = 247;
  Button21.Width           = 79;
  Button21.Height          = 29;
  Button21.Pen_Width       = 1;
  Button21.Pen_Color       = 0x0000;
  Button21.Visible         = 1;
  Button21.Active          = 1;
  Button21.Transparent     = 1;
  Button21.Caption         = Button21_Caption;
  Button21.FontName        = Tahoma14x16_Bold;
  Button21.PressColEnabled = 1;
  Button21.Font_Color      = 0x0000;
  Button21.Gradient        = 1;
  Button21.Gradient_Orientation    = 0;
  Button21.Gradient_Start_Color    = 0xFFFF;
  Button21.Gradient_End_Color      = 0xC618;
  Button21.Color           = 0xC618;
  Button21.Press_Color     = 0xC618;
  Button21.OnUpPtr         = 0;
  Button21.OnDownPtr       = ShowMainScreen;
  Button21.OnClickPtr      = 0;
  Button21.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetButton(index)              CurrentScreen->Buttons[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetBox(index)                 CurrentScreen->Boxes[index]


void DrawButton(TButton *Abutton) {
  if (Abutton->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    TFT_Write_Text(Abutton->Caption, (Abutton->Left + ((Abutton->Width - caption_length) / 2)), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
  }
}

void DrawLabel(TLabel *ALabel) {
int x_pos, y_pos;
  x_pos = 0;
  y_pos = 0;
  if (ALabel->Visible == 1) {
    TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(ALabel->Caption, ALabel->Left, ALabel->Top);
    x_pos = ALabel->Left + ((int)(ALabel->Width - caption_length) / 2);
    y_pos = ALabel->Top + ((int)(ALabel->Height - caption_height) / 2);
    if (x_pos > ALabel->Left) {
      TFT_Write_Text(ALabel->Caption, x_pos, y_pos);
    }
    else {
      TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
    }
  }
}

void DrawBox(TBox *ABox) {
  if (ABox->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
    }
    TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
    TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
  }
}

void DrawScreen(TScreen *aScreen) {
  unsigned short order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short box_idx;
  TBox *local_box;
  char save_bled, save_bled_direction;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  label_idx = 0;
  box_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    save_bled_direction = TFT_BLED_Direction;
    TFT_BLED_Direction = 0;
    TFT_BLED           = 0;
    TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
    TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 0, 1);                                  // Initialize touch panel
    TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold
    TFT_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
    TFT_BLED_Direction = save_bled_direction;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (button_idx < CurrentScreen->ButtonsCount) {
      local_button = GetButton(button_idx);
      if (order == local_button->Order) {
        button_idx++;
        order++;
        DrawButton(local_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (box_idx < CurrentScreen->BoxesCount) {
      local_box = GetBox(box_idx);
      if (order == local_box->Order) {
        box_idx++;
        order++;
        DrawBox(local_box);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  button_order        = -1;
  label_order         = -1;
  box_order           = -1;
  //  Buttons
  for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
    local_button = GetButton(_object_count);
    if (local_button->Active == 1) {
      if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
                         local_button->Width, local_button->Height) == 1) {
        button_order = local_button->Order;
        exec_button = local_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active == 1) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  Boxes
  for ( _object_count = 0 ; _object_count < CurrentScreen->BoxesCount ; _object_count++ ) {
    local_box = GetBox(_object_count);
    if (local_box->Active == 1) {
      if (IsInsideObject(X, Y, local_box->Left, local_box->Top,
                         local_box->Width, local_box->Height) == 1) {
        box_order = local_box->Order;
        exec_box = local_box;
      }
    }
  }

  _object_count = -1;
  if (button_order > _object_count)
    _object_count = button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (box_order >  _object_count )
    _object_count = box_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_button         = 0;
  exec_label          = 0;
  exec_box            = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active == 1) {
        if (exec_button->OnPressPtr != 0) {
          exec_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->OnPressPtr != 0) {
          exec_box->OnPressPtr();
          return;
        }
      }
    }

  }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Button
    case 0: {
      if (PressedObject != 0) {
        exec_button = (TButton*)PressedObject;
        if ((exec_button->PressColEnabled == 1) && (exec_button->OwnerScreen == CurrentScreen)) {
          DrawButton(exec_button);
        }
        break;
      }
      break;
    }
    // Box
    case 6: {
      if (PressedObject != 0) {
        exec_box = (TBox*)PressedObject;
        if ((exec_box->PressColEnabled == 1) && (exec_box->OwnerScreen == CurrentScreen)) {
          DrawBox(exec_box);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons
    if (_object_count == button_order) {
      if (exec_button->Active == 1) {
        if (exec_button->OnUpPtr != 0)
          exec_button->OnUpPtr();
        if (PressedObject == (void *)exec_button)
          if (exec_button->OnClickPtr != 0)
            exec_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (void *)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes
    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->OnUpPtr != 0)
          exec_box->OnUpPtr();
        if (PressedObject == (void *)exec_box)
          if (exec_box->OnClickPtr != 0)
            exec_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_button         = 0;
  exec_label          = 0;
  exec_box            = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active == 1) {
        if (exec_button->PressColEnabled == 1) {
          object_pressed = 1;
          DrawButton(exec_button);
        }
        PressedObject = (void *)exec_button;
        PressedObjectType = 0;
        if (exec_button->OnDownPtr != 0) {
          exec_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        PressedObject = (void *)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->PressColEnabled == 1) {
          object_pressed = 1;
          DrawBox(exec_box);
        }
        PressedObject = (void *)exec_box;
        PressedObjectType = 6;
        if (exec_box->OnDownPtr != 0) {
          exec_box->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (TP_TFT_Press_Detect()) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
    if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU() {
  TP_TFT_Rotate_180(0);
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();

  Delay_ms(1000);
  TFT_Fill_Screen(0);
  Calibrate();
  TFT_Fill_Screen(0);

  InitializeObjects();
  display_width = MainScreen.Width;
  display_height = MainScreen.Height;
  DrawScreen(&MainScreen);
}
