enum GlcdColor {_clClear, _clDraw, _clInvert};

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
};

extern   TScreen                MainScreen;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TButton               Button5;
extern   TButton               Button6;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TButton               Button9;
extern   TButton               Button10;
extern   TButton               Button11;
extern   TButton               Button12;
extern   TButton               Button13;
extern   TButton               Button14;
extern   TButton               Button15;
extern   TBox                   Box1;
extern   TBox                   Menu;
extern   TLabel                 Label1;
extern   TLabel                 Label2;
extern   TLabel                 Label4;
extern   TBox                   StatusBar;
extern   TLabel                 Label6;
extern   TLabel                 Label7;
extern   TButton               Empty;
extern   TButton                * const code Screen1_Buttons[16];
extern   TLabel                 * const code Screen1_Labels[5];
extern   TBox                   * const code Screen1_Boxes[3];


extern   TScreen                Help;
extern   TBox                   Box5;
extern   TBox                   Box6;
extern   TLabel                 Label13;
extern   TLabel                 Label14;
extern   TLabel                 Label16;
extern   TBox                   Box7;
extern   TLabel                 Label30;
extern   TLabel                 Label31;
extern   TLabel                 Label32;
extern   TLabel                 Label33;
extern   TLabel                 Label34;
extern   TLabel                 Label35;
extern   TLabel                 Label36;
extern   TLabel                 Label37;
extern   TLabel                 Label38;
extern   TLabel                 Label39;
extern   TLabel                 * const code Screen2_Labels[13];
extern   TBox                   * const code Screen2_Boxes[3];


extern   TScreen                Victory;
extern   TBox                   Box13;
extern   TBox                   Box11;
extern   TLabel                 Label43;
extern   TLabel                 Label44;
extern   TLabel                 Label46;
extern   TBox                   Box12;
extern   TLabel                 Label48;
extern   TLabel                 Label49;
extern   TLabel                 Label50;
extern   TLabel                 Label51;
extern   TButton               Button21;
extern   TButton                * const code Screen3_Buttons[1];
extern   TLabel                 * const code Screen3_Labels[7];
extern   TBox                   * const code Screen3_Boxes[3];



/////////////////////////
// Events Code Declarations
void Button1Down();
void Button2Down();
void Button3Down();
void Button4Down();
void Button5Down();
void Button6Down();
void Button7Down();
void Button8Down();
void Button9Down();
void Button10Down();
void Button11Down();
void Button12Down();
void Button13Down();
void Button14Down();
void Button15Down();
void NewGame();
void ShowHelpScreen();
void ShowMainScreen();
void ShowMainScreen();
void ShowHelpScreen();
void ShowMainScreen();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button11_Caption[];
extern char Button12_Caption[];
extern char Button13_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label4_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label13_Caption[];
extern char Label14_Caption[];
extern char Label16_Caption[];
extern char Label30_Caption[];
extern char Label31_Caption[];
extern char Label32_Caption[];
extern char Label33_Caption[];
extern char Label34_Caption[];
extern char Label35_Caption[];
extern char Label36_Caption[];
extern char Label37_Caption[];
extern char Label38_Caption[];
extern char Label39_Caption[];
extern char Label43_Caption[];
extern char Label44_Caption[];
extern char Label46_Caption[];
extern char Label48_Caption[];
extern char Label49_Caption[];
extern char Label50_Caption[];
extern char Label51_Caption[];
extern char Button21_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawBox(TBox *ABox);
void Check_TP();
void Start_TP();
